Index: TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/TvBusinessLayer.csproj
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/TvBusinessLayer.csproj	(revision 28196)
+++ TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/TvBusinessLayer.csproj	(working copy)
@@ -74,6 +74,9 @@
     </Reference>
     <Reference Include="System.Data" />
     <Reference Include="System.Xml" />
+    <Reference Include="TvControl">
+      <HintPath>..\..\TvControl\bin\Release\TvControl.dll</HintPath>
+    </Reference>
   </ItemGroup>
   <ItemGroup>
     <Compile Include="..\..\..\..\Common-MP-TVE3\SolutionInfo.cs">
Index: TvEngine3/TVLibrary/TVDatabase/TVDatabase.csproj
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/TVDatabase.csproj	(revision 28196)
+++ TvEngine3/TVLibrary/TVDatabase/TVDatabase.csproj	(working copy)
@@ -110,6 +110,10 @@
     <Compile Include="CardGroupMap.cs" />
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\..\Common-MP-TVE3\DirectShowLib\DirectShowLib.csproj">
+      <Project>{CE009BFA-5EF6-4153-B2A1-2FA79698A9AE}</Project>
+      <Name>DirectShowLib</Name>
+    </ProjectReference>
     <ProjectReference Include="..\TvLibrary.Interfaces\TvLibrary.Interfaces.csproj">
       <Project>{AE752FB4-7450-4150-9BAD-19EFA9D2AC37}</Project>
       <Name>TvLibrary.Interfaces</Name>
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/ATSC/TvCardATSC.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/ATSC/TvCardATSC.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/ATSC/TvCardATSC.cs	(working copy)
@@ -320,7 +320,7 @@
         }
         foreach (TuningDetail detail in dbchannel.ReferringTuningDetail())
         {
-          if (detail.ChannelType == 1)
+          if (detail.ChannelType == ChannelProviderType.ATSC)
           {
             atscchannel.MajorChannel = detail.MajorChannel;
             atscchannel.MinorChannel = detail.MinorChannel;
@@ -369,6 +369,14 @@
       return true;
     }
 
+    /// <summary>
+    /// Method to create channel and fill it with given in arguments parameters
+    /// </summary>
+    /// <param name="networkid"></param>
+    /// <param name="transportid"></param>
+    /// <param name="serviceid"></param>
+    /// <param name="name"></param>
+    /// <returns>new ATSCChannel</returns>
     protected override DVBBaseChannel CreateChannel(int networkid, int transportid, int serviceid, string name)
     {
       ATSCChannel channel = new ATSCChannel();
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBC/TvCardDVBC.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBC/TvCardDVBC.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBC/TvCardDVBC.cs	(working copy)
@@ -313,7 +313,7 @@
         }
         foreach (TuningDetail detail in dbchannel.ReferringTuningDetail())
         {
-          if (detail.ChannelType == 2)
+          if (detail.ChannelType == ChannelProviderType.DVBC)
           {
             dvbcchannel.Frequency = detail.Frequency;
             dvbcchannel.ModulationType = (ModulationType)detail.Modulation;
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBS/TvCardDVBS.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBS/TvCardDVBS.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBS/TvCardDVBS.cs	(working copy)
@@ -428,7 +428,7 @@
         }
         foreach (TuningDetail detail in dbchannel.ReferringTuningDetail())
         {
-          if (detail.ChannelType == 3)
+          if (detail.ChannelType == ChannelProviderType.DVBS)
           {
             dvbschannel.Frequency = detail.Frequency;
             dvbschannel.Polarisation = (Polarisation)detail.Polarisation;
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBT/TvCardDVBT.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBT/TvCardDVBT.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/DVBT/TvCardDVBT.cs	(working copy)
@@ -302,7 +302,7 @@
         }
         foreach (TuningDetail detail in dbchannel.ReferringTuningDetail())
         {
-          if (detail.ChannelType == 4)
+          if (detail.ChannelType == ChannelProviderType.DVBT)
           {
             dvbtchannel.Frequency = detail.Frequency;
             dvbtchannel.BandWidth = detail.Bandwidth;
Index: TvEngine3/TVLibrary/TVLibrary/TimeShiftingEPGGrabber.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/TimeShiftingEPGGrabber.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TVLibrary/TimeShiftingEPGGrabber.cs	(working copy)
@@ -54,7 +54,7 @@
       double timeout;
       if (!double.TryParse(layer.GetSetting("timeshiftingEpgGrabberTimeout", "2").Value, out timeout))
         timeout = 2;
-      _epgTimer.Interval = timeout * 60000;
+      _epgTimer.Interval = timeout * 1000;
     }
 
     public bool StartGrab()
Index: TvEngine3/TVLibrary/TvService/Epg/EpgGrabber.cs
===================================================================
--- TvEngine3/TVLibrary/TvService/Epg/EpgGrabber.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TvService/Epg/EpgGrabber.cs	(working copy)
@@ -269,15 +269,15 @@
           continue;
 
         //check if card type is the same as the channel type of the transponder
-        if (type == CardType.Atsc && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != 1)
+        if (type == CardType.Atsc && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != ChannelProviderType.ATSC)
           continue;
-        if (type == CardType.DvbC && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != 2)
+        if (type == CardType.DvbC && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != ChannelProviderType.DVBC)
           continue;
-        if (type == CardType.DvbS && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != 3)
+        if (type == CardType.DvbS && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != ChannelProviderType.DVBS)
           continue;
-        if (type == CardType.DvbT && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != 4)
+        if (type == CardType.DvbT && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != ChannelProviderType.DVBT)
           continue;
-        if (type == CardType.DvbIP && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != 7)
+        if (type == CardType.DvbIP && TransponderList.Instance.CurrentTransponder.TuningDetail.ChannelType != ChannelProviderType.DVBIP)
           continue;
 
         //find next channel to grab
Index: TvEngine3/TVLibrary/TvService/Epg/Transponder.cs
===================================================================
--- TvEngine3/TVLibrary/TvService/Epg/Transponder.cs	(revision 28196)
+++ TvEngine3/TVLibrary/TvService/Epg/Transponder.cs	(working copy)
@@ -176,7 +176,7 @@
     /// </summary>
     public override int GetHashCode()
     {
-      return TuningDetail.Frequency + TuningDetail.ChannelType;
+      return TuningDetail.Frequency + (int)TuningDetail.ChannelType;
     }
 
     /// <summary>
@@ -267,7 +267,7 @@
         foreach (TuningDetail detail in channel.ReferringTuningDetail())
         {
           //skip analog channels and webstream channels
-          if (detail.ChannelType == 0 || detail.ChannelType == 5)
+          if (detail.ChannelType == ChannelProviderType.Analog || detail.ChannelType == ChannelProviderType.WebStream)
             continue;
 
           //create a new transponder
